import sys

# Activations
from scratchai.build._internal._activation import Linear, Sigmoid, ReLU, SoftPlus, Tanh, SoftMax

# Model building blocks
from scratchai.build._internal._block import (Layer, HiddenLayer, LinearOutpotLayer, 
ReLUOutpotLayer, SigmoidOutpotLayer, SoftmaxOutpotLayer)

# build_model function
from scratchai.build._internal._create import build_model

__all__ = ['Linear', 'Sigmoid', 'ReLU', 'SoftPlus', 'Tanh', 'SoftMax',
           'Layer', 'HiddenLayer', 'LinearOutpotLayer', 'ReLUOutpotLayer',
           'SigmoidOutpotLayer', 'SoftmaxOutpotLayer', 'build_model']

# Hide internel modules
for _mod in ['_activation', '_block', '_create', '_loss']:
    sys.modules.pop(f"{__name__}.{_mod}", None)